--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--Codec for Akai APC MINI JammeR RE
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
function remote_init(manufacturer, model)

	--check this is the right model
    assert(model=="APCMini_JammeR")
    --define a table with all the items on the control surface
	local items={
		{name="Control 01", input="value", output="value", min=0, max=1},
		{name="Control 02", input="value", output="value", min=0, max=1},
		{name="Control 03", input="value", output="value", min=0, max=1},
		{name="Control 04", input="value", output="value", min=0, max=1},
		{name="Control 05", input="value", output="value", min=0, max=1},
		{name="Control 06", input="value", output="value", min=0, max=1},
		{name="Control 07", input="value", output="value", min=0, max=1},
		{name="Control 08", input="value", output="value", min=0, max=1},
		{name="Control 1", input="value", output="value", min=0, max=1},
		{name="Control 2", input="value", output="value", min=0, max=1},
		{name="Control 3", input="value", output="value", min=0, max=1},
		{name="Control 4", input="value", output="value", min=0, max=1},
		{name="Control 5", input="value", output="value", min=0, max=1},
		{name="Control 6", input="value", output="value", min=0, max=1},
		{name="Control 7", input="value", output="value", min=0, max=1},
		{name="Control 8", input="value", output="value", min=0, max=1},
		{name="Control 9", input="value", output="value", min=0, max=1},
		{name="Control 10", input="value", output="value", min=0, max=1},
		{name="Control 11", input="value", output="value", min=0, max=1},
		{name="Control 12", input="value", output="value", min=0, max=1},
		{name="Control 13", input="value", output="value", min=0, max=1},
		{name="Control 14", input="value", output="value", min=0, max=1},
		{name="Control 15", input="value", output="value", min=0, max=7},
		{name="Control 16", input="value", output="value", min=0, max=7},
		{name="Control 17", input="value", output="value", min=0, max=7},
		{name="Control 18", input="value", output="value", min=0, max=7},
		{name="Control 19", input="value", output="value", min=0, max=7},
		{name="Control 20", input="value", output="value", min=0, max=7},
		{name="Control 21", input="value", output="value", min=0, max=1},
		{name="Control 22", input="value", output="value", min=0, max=1},
		{name="Control 23", input="value", output="value", min=0, max=1},
		{name="Control 24", input="value", output="value", min=0, max=1},
		{name="Control 25", input="value", output="value", min=0, max=1},
		{name="Control 26", input="value", output="value", min=0, max=1},
		{name="Control 27", input="value", output="value", min=0, max=1},
		{name="Control 28", input="value", output="value", min=0, max=1},
		{name="Control 29", input="value", output="value", min=0, max=1},
		{name="Control 30", input="value", output="value", min=0, max=1},
		{name="Control 31", input="value", output="value", min=0, max=1},
		{name="Control 32", input="value", output="value", min=0, max=1},
		{name="Control 33", input="value", output="value", min=0, max=1},
		{name="Control 34", input="value", output="value", min=0, max=1},
		{name="Control 35", input="value", output="value", min=0, max=1},
		{name="Control 36", input="value", output="value", min=0, max=1},
		{name="Control 37", input="value", output="value", min=0, max=1},
		{name="Control 38", input="value", output="value", min=0, max=1},
		{name="Control 39", input="value", output="value", min=0, max=1},
		{name="Control 40", input="value", output="value", min=0, max=1},
		{name="Control 41", input="value", output="value", min=0, max=1},
		{name="Control 42", input="value", output="value", min=0, max=1},
		{name="Control 43", input="value", output="value", min=0, max=1},
		{name="Control 44", input="value", output="value", min=0, max=1},
		{name="Control 45", input="value", output="value", min=0, max=1},
		{name="Control 46", input="value", output="value", min=0, max=1},
		{name="Control 47", input="value", output="value", min=0, max=1},
		{name="Control 48", input="value", output="value", min=0, max=1},
		{name="Control 49", input="value", output="value", min=0, max=1},
		{name="Control 50", input="value", output="value", min=0, max=1},
		{name="Control 51", input="value", output="value", min=0, max=1},
		{name="Control 52", input="value", output="value", min=0, max=1},
		{name="Control 53", input="value", output="value", min=0, max=1},
		{name="Control 54", input="value", output="value", min=0, max=1},
		{name="Control 55", input="value", output="value", min=0, max=1},
		{name="Control 56", input="value", output="value", min=0, max=1},
		{name="Control 57", input="value", output="value", min=0, max=1},
		{name="Control 58", input="value", output="value", min=0, max=1},
		{name="Control 59", input="value", output="value", min=0, max=1},
		{name="Control 60", input="value", output="value", min=0, max=1},
		{name="Control 61", input="value", output="value", min=0, max=1},
		{name="Control 62", input="value", output="value", min=0, max=1},
		{name="Control 63", input="value", output="value", min=0, max=1},
		{name="Control 64", input="value", output="value", min=0, max=1},
		{name="Control 65", input="value", output="value", min=0, max=1},
		{name="Control 66", input="value", output="value", min=0, max=1},
		{name="Control 67", input="value", output="value", min=0, max=1},
		{name="Control 68", input="value", output="value", min=0, max=1},
		{name="Control 69", input="value", output="value", min=0, max=1},
		{name="Control 70", input="value", output="value", min=0, max=1},
		{name="Control 71", input="value", output="value", min=0, max=1},
		{name="Control 72", input="value", output="value", min=0, max=1},
		{name="Control 73", input="value", output="value", min=0, max=1},
		{name="Control 74", input="value", output="value", min=0, max=1},
		{name="Control 75", input="value", output="value", min=0, max=1},
		{name="Control 76", output="text"}
		}
	remote.define_items(items)	
end
function remote_probe(manufacturer,model)
assert(model=="APCMini_JammeR")
return {
request="f0 7e 7f 06 01 f7",
response="f0 7e 7f 06 02 56 66 66 01 03 ?? ?? ?? ?? f7"
}
end
u562werf = 84
asdgfote = {1, 2, 3, 4, 5, 6, 7, 8}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
dfa34wras = {17, 18, 19, 20, 21, 22}
uiqwassr = {23, 24, 25, 26, 27, 28}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
gfhjrsvb = {0, 0, 0, 0, 0, 0, 0, 0}
chjklwfd =  {0, 0, 0, 0, 0, 0, 0, 0}
tcvnfhso ={}
pafgskjl={}
nfsvsxvzz ={}
for i =1, 48, 1 do
table.insert(tcvnfhso, 28+i)
table.insert(pafgskjl, 0)
table.insert(nfsvsxvzz, 0)
end
lnswegfd = {"<1001>? 38 xx", "<1001>? 39 xx", "<1001>? 3a xx", "<1001>? 3b xx", "<1001>? 3c xx", "<1001>? 3d xx", 
"<1001>? 30 xx", "<1001>? 31 xx", "<1001>? 32 xx", "<1001>? 33 xx", "<1001>? 34 xx", "<1001>? 35 xx", 
"<1001>? 28 xx", "<1001>? 29 xx", "<1001>? 2a xx", "<1001>? 2b xx", "<1001>? 2c xx", "<1001>? 2d xx", 
"<1001>? 20 xx", "<1001>? 21 xx", "<1001>? 22 xx", "<1001>? 23 xx", "<1001>? 24 xx", "<1001>? 25 xx",  
"<1001>? 18 xx", "<1001>? 19 xx", "<1001>? 1a xx", "<1001>? 1b xx", "<1001>? 1c xx", "<1001>? 1d xx",  
"<1001>? 10 xx", "<1001>? 11 xx", "<1001>? 12 xx", "<1001>? 13 xx", "<1001>? 14 xx", "<1001>? 15 xx", 
"<1001>? 08 xx", "<1001>? 09 xx", "<1001>? 0a xx", "<1001>? 0b xx", "<1001>? 0c xx", "<1001>? 0d xx",
"<1001>? 00 xx", "<1001>? 01 xx", "<1001>? 02 xx", "<1001>? 03 xx", "<1001>? 04 xx", "<1001>? 05 xx"}
bklkdsret = {"<1001>? 3f xx", "<1001>? 37 xx", "<1001>? 2f xx",  "<1001>? 27 xx", "<1001>? 1f xx", 
"<1001>? 17 xx", "<1001>? 0f xx", "<1001>? 07 xx"}
pommnjhg = {63, 55, 47, 39, 31, 23, 15, 7}
ertgfsdgb = {56, 57, 58, 59, 60, 61, 48, 49, 50, 51, 52, 53, 40, 41, 42, 43, 44, 45, 32, 33, 34, 35, 36, 37, 24, 25, 26, 27, 28, 29, 16, 17, 18, 19, 20, 21, 8, 9, 10, 11, 12, 13, 0, 1, 2, 3, 4, 5}
mv999fdg = {56, 57, 58, 59, 60, 61, 62, 63, 48, 49, 50, 51, 52, 53, 54, 55, 40, 41, 42, 43, 44, 45, 46, 47, 32, 33, 34, 35, 36, 37, 38, 39, 24, 25, 26, 27, 28, 29, 30, 31, 16, 17, 18, 19, 20, 21, 22, 23, 8, 9, 10, 11, 12, 13, 14, 15, 0, 1, 2, 3, 4, 5 ,6, 7}
kxcver = 0
tslkfgnxz =0
nbtygllo = "<1001>? 06 xx"
lklertgzq = 77
sdf45weio = {78, 79, 80, 81, 82, 83}
function remote_process_midi(mhjk4we)
for i = 1, 8, 1 do 
local jpioretvvc = remote.match_midi(bklkdsret[i], mhjk4we)
if jpioretvvc ~= nil then 
if kxcver == 0 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=asdgfote[i], value= jpioretvvc.x/127}
remote.handle_input(msg)
return true
elseif kxcver == 1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= jpioretvvc.x/127}
remote.handle_input(msg2)
return true
end	
end
end
local sdfhaae9ut = 0
for i = 1, 48, 1 do 
local jpioretvvc = remote.match_midi(lnswegfd[i], mhjk4we)
if jpioretvvc ~= nil then 
local reneeder = i - math.floor(i/6)*6
local valogshi = 0
if reneeder == 0 then
sdfhaae9ut = 6
valogshi = i/6 - 1
else
sdfhaae9ut = reneeder
valogshi = math.floor(i/6)
end
if kxcver == 0 then 			
local msg = {time_stamp=mhjk4we.time_stamp, item=dfa34wras[sdfhaae9ut], value= jpioretvvc.x/127}
remote.handle_input(msg)
if jpioretvvc.x/127 ==1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=uiqwassr[sdfhaae9ut], value= valogshi}
remote.handle_input(msg2)
end	
return true
elseif kxcver == 1 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= jpioretvvc.x/127}
remote.handle_input(msg)
return true
end		
end
end
local jpioretvvc = remote.match_midi(nbtygllo, mhjk4we)
if jpioretvvc ~= nil then 
if jpioretvvc.x == 127 then
kxcver = 1
else
kxcver = 0 
local msg = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= 0}
remote.handle_input(msg)
if sdfhaae9ut ~= 0 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= 0}
remote.handle_input(msg2)
return true
end	
end
end			 
end		
otr684dds = nil
otr732dds = nil
trdds43txx = false
function remote_set_state(changed_items)
for i,imbtrdcx in ipairs(changed_items) do
if imbtrdcx == u562werf then
otr684dds = remote.get_item_text_value(u562werf)
if otr684dds == "5" and otr732dds ~= otr684dds then
trdds43txx = true
else
trdds43txx = false
end	
otr732dds = otr684dds
end
if imbtrdcx>=9 and imbtrdcx<=16 then
for i =1, 8, 1 do 
if imbtrdcx == lkjvcds[i] then 
gfhjrsvb[i]=remote.get_item_value(imbtrdcx)
end	
end	
end	
if imbtrdcx>=29 and imbtrdcx <= 76 then
for i =1, 48, 1 do
if imbtrdcx == tcvnfhso[i] then 
pafgskjl[i] = remote.get_item_value(imbtrdcx)
end
end	
end
end	
end			
local function maewrgjj4f(ottre5j)
local i5tteioqq = pommnjhg[ottre5j]
local t43ekgvvf = gfhjrsvb[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 1}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
end
return mhjk4we
end		
local function tr43msdvred(ottre5j)
local i5tteioqq = ertgfsdgb[ottre5j]
local t43ekgvvf = pafgskjl[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 1}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
end	
return mhjk4we
end		
function remote_deliver_midi()
local d34jk5fds={}
if trdds43txx == true then 
for i = 1, 64, 1 do
local la2113wsebv = mv999fdg[i]
mhjk4we={128, la2113wsebv, 0}
mhjk4we.size = 3
table.insert(d34jk5fds, mhjk4we)
end	
trdds43txx = false	
end
for i = 1, 8, 1 do
if chjklwfd[i] ~= gfhjrsvb[i] then
local imbtrdcx = lkjvcds[i]
local mhjk4we = maewrgjj4f(i)
table.insert(d34jk5fds,mhjk4we)
chjklwfd[i] = gfhjrsvb[i]
end
end
for i = 1, 48, 1 do
if nfsvsxvzz[i] ~= pafgskjl[i] then
local imbtrdcx = tcvnfhso[i]
local mhjk4we = tr43msdvred(i)
table.insert(d34jk5fds,mhjk4we)
nfsvsxvzz[i] = pafgskjl[i]
end
end	
if kxcver ~= tslkfgnxz then 
if kxcver == 1 then 
local mhjk4we = {144, 6, 3}
mhjk4we.size = 3
table.insert(d34jk5fds,mhjk4we)
elseif kxcver ==0 then 
local mhjk4we = {144, 6, 0}
mhjk4we.size = 3	
table.insert(d34jk5fds,mhjk4we)
end
tslkfgnxz = kxcver
end
return d34jk5fds
end


function remote_prepare_for_use()
local ret_events = {}
return ret_events
end
function remote_release_from_use()
end










