--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--Codec for NI Maschine Jam - JammeR RE
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
function remote_init(manufacturer, model)

	--check this is the right model
    assert(model=="NIJam_JammeR")
    --define a table with all the items on the control surface
	local items={
		{name="Control 01", input="value", output="value", min=0, max=1},
		{name="Control 02", input="value", output="value", min=0, max=1},
		{name="Control 03", input="value", output="value", min=0, max=1},
		{name="Control 04", input="value", output="value", min=0, max=1},
		{name="Control 05", input="value", output="value", min=0, max=1},
		{name="Control 06", input="value", output="value", min=0, max=1},
		{name="Control 07", input="value", output="value", min=0, max=1},
		{name="Control 08", input="value", output="value", min=0, max=1},
		{name="Control 1", input="value", output="value", min=0, max=1},
		{name="Control 2", input="value", output="value", min=0, max=1},
		{name="Control 3", input="value", output="value", min=0, max=1},
		{name="Control 4", input="value", output="value", min=0, max=1},
		{name="Control 5", input="value", output="value", min=0, max=1},
		{name="Control 6", input="value", output="value", min=0, max=1},
		{name="Control 7", input="value", output="value", min=0, max=1},
		{name="Control 8", input="value", output="value", min=0, max=1},
		{name="Control 9", input="value", output="value", min=0, max=1},
		{name="Control 10", input="value", output="value", min=0, max=1},
		{name="Control 11", input="value", output="value", min=0, max=1},
		{name="Control 12", input="value", output="value", min=0, max=1},
		{name="Control 13", input="value", output="value", min=0, max=1},
		{name="Control 14", input="value", output="value", min=0, max=1},
		{name="Control 15", input="value", output="value", min=0, max=7},
		{name="Control 16", input="value", output="value", min=0, max=7},
		{name="Control 17", input="value", output="value", min=0, max=7},
		{name="Control 18", input="value", output="value", min=0, max=7},
		{name="Control 19", input="value", output="value", min=0, max=7},
		{name="Control 20", input="value", output="value", min=0, max=7},
		{name="Control 21", input="value", output="value", min=0, max=1},
		{name="Control 22", input="value", output="value", min=0, max=1},
		{name="Control 23", input="value", output="value", min=0, max=1},
		{name="Control 24", input="value", output="value", min=0, max=1},
		{name="Control 25", input="value", output="value", min=0, max=1},
		{name="Control 26", input="value", output="value", min=0, max=1},
		{name="Control 27", input="value", output="value", min=0, max=1},
		{name="Control 28", input="value", output="value", min=0, max=1},
		{name="Control 29", input="value", output="value", min=0, max=1},
		{name="Control 30", input="value", output="value", min=0, max=1},
		{name="Control 31", input="value", output="value", min=0, max=1},
		{name="Control 32", input="value", output="value", min=0, max=1},
		{name="Control 33", input="value", output="value", min=0, max=1},
		{name="Control 34", input="value", output="value", min=0, max=1},
		{name="Control 35", input="value", output="value", min=0, max=1},
		{name="Control 36", input="value", output="value", min=0, max=1},
		{name="Control 37", input="value", output="value", min=0, max=1},
		{name="Control 38", input="value", output="value", min=0, max=1},
		{name="Control 39", input="value", output="value", min=0, max=1},
		{name="Control 40", input="value", output="value", min=0, max=1},
		{name="Control 41", input="value", output="value", min=0, max=1},
		{name="Control 42", input="value", output="value", min=0, max=1},
		{name="Control 43", input="value", output="value", min=0, max=1},
		{name="Control 44", input="value", output="value", min=0, max=1},
		{name="Control 45", input="value", output="value", min=0, max=1},
		{name="Control 46", input="value", output="value", min=0, max=1},
		{name="Control 47", input="value", output="value", min=0, max=1},
		{name="Control 48", input="value", output="value", min=0, max=1},
		{name="Control 49", input="value", output="value", min=0, max=1},
		{name="Control 50", input="value", output="value", min=0, max=1},
		{name="Control 51", input="value", output="value", min=0, max=1},
		{name="Control 52", input="value", output="value", min=0, max=1},
		{name="Control 53", input="value", output="value", min=0, max=1},
		{name="Control 54", input="value", output="value", min=0, max=1},
		{name="Control 55", input="value", output="value", min=0, max=1},
		{name="Control 56", input="value", output="value", min=0, max=1},
		{name="Control 57", input="value", output="value", min=0, max=1},
		{name="Control 58", input="value", output="value", min=0, max=1},
		{name="Control 59", input="value", output="value", min=0, max=1},
		{name="Control 60", input="value", output="value", min=0, max=1},
		{name="Control 61", input="value", output="value", min=0, max=1},
		{name="Control 62", input="value", output="value", min=0, max=1},
		{name="Control 63", input="value", output="value", min=0, max=1},
		{name="Control 64", input="value", output="value", min=0, max=1},
		{name="Control 65", input="value", output="value", min=0, max=1},
		{name="Control 66", input="value", output="value", min=0, max=1},
		{name="Control 67", input="value", output="value", min=0, max=1},
		{name="Control 68", input="value", output="value", min=0, max=1},
		{name="Control 69", input="value", output="value", min=0, max=1},
		{name="Control 70", input="value", output="value", min=0, max=1},
		{name="Control 71", input="value", output="value", min=0, max=1},
		{name="Control 72", input="value", output="value", min=0, max=1},
		{name="Control 73", input="value", output="value", min=0, max=1},
		{name="Control 74", input="value", output="value", min=0, max=1},
		{name="Control 75", input="value", output="value", min=0, max=1},
		{name="Control 76", output="text"}
		}
	remote.define_items(items)	
end
function remote_probe(manufacturer,model)
assert(model=="NIJam_JammeR")
return {
request="f0 7e 7f 06 01 f7",
response="f0 7e 7f 06 02 56 66 66 01 03 ?? ?? ?? ?? f7"
}
end
u562werf = 84
asdgfote = {1, 2, 3, 4, 5, 6, 7, 8}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
dfa34wras = {17, 18, 19, 20, 21, 22}
uiqwassr = {23, 24, 25, 26, 27, 28}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
gfhjrsvb = {0, 0, 0, 0, 0, 0, 0, 0}
chjklwfd =  {0, 0, 0, 0, 0, 0, 0, 0}
tcvnfhso ={}
pafgskjl={}
nfsvsxvzz ={}
for i =1, 48, 1 do
table.insert(tcvnfhso, 28+i)
table.insert(pafgskjl, 0)
table.insert(nfsvsxvzz, 0)
end
lnswegfd = {"<100x>? 5c yy", "<100x>? 5d yy", "<100x>? 5e yy", "<100x>? 5f yy", "<100x>? 60 yy", "<100x>? 61 yy", 
"<100x>? 54 yy", "<100x>? 55 yy", "<100x>? 56 yy", "<100x>? 57 yy", "<100x>? 58 yy", "<100x>? 59 yy",
"<100x>? 4c yy", "<100x>? 4d yy", "<100x>? 4e yy", "<100x>? 4f yy", "<100x>? 50 yy", "<100x>? 51 yy", 
"<100x>? 44 yy", "<100x>? 45 yy", "<100x>? 46 yy", "<100x>? 47 yy", "<100x>? 48 yy", "<100x>? 49 yy",  
"<100x>? 3c yy", "<100x>? 3d yy", "<100x>? 3e yy", "<100x>? 3f yy", "<100x>? 40 yy", "<100x>? 41 yy", 
"<100x>? 34 yy", "<100x>? 35 yy", "<100x>? 36 yy", "<100x>? 37 yy", "<100x>? 38 yy", "<100x>? 39 yy",  
"<100x>? 2c yy", "<100x>? 2d yy", "<100x>? 2e yy", "<100x>? 2f yy", "<100x>? 30 yy", "<100x>? 31 yy",  
"<100x>? 24 yy", "<100x>? 25 yy", "<100x>? 26 yy", "<100x>? 27 yy", "<100x>? 28 yy", "<100x>? 29 yy",}
bklkdsret = {"<1001>? 63 xx", "<1001>? 5b xx", "<1001>? 53 xx", "<1001>? 4b xx", "<1001>? 43 xx", 
"<1001>? 3b xx", "<1001>? 33 xx", "<1001>? 2b xx"}
pommnjhg = {99, 91, 83, 75, 67, 59, 51, 43}
ertgfsdgb = {92, 93, 94, 95, 96, 97, 84, 85, 86, 87, 88, 89,  76, 77, 78, 79, 80, 81, 
68, 69, 70, 71, 72, 73, 60, 61, 62, 63, 64, 65,  52, 53, 54, 55, 56, 57,  44, 45, 46, 47, 48, 49,  
36, 37, 38, 39, 40, 41 }
mv999fdg = {92, 93, 94, 95, 96, 97, 98, 99, 84, 85, 86, 87, 88, 89, 90, 91, 76, 77, 78, 79, 80, 81, 82, 83, 
68, 69, 70, 71, 72, 73, 74, 75, 60, 61, 62, 63, 64, 65, 66, 67, 52, 53, 54, 55, 56, 57, 58, 59, 44, 45, 46, 47, 48, 49, 50, 51, 
36, 37, 38, 39, 40, 41 ,42, 43}
kxcver = 0
tslkfgnxz =0
nbtygllo = "<1001>? 2a xx"
lklertgzq = 77
sdf45weio = {78, 79, 80, 81, 82, 83}
function remote_process_midi(mhjk4we)
for i = 1, 8, 1 do 
local jpioretvvc = remote.match_midi(bklkdsret[i], mhjk4we)
if jpioretvvc ~= nil then 
if kxcver == 0 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=asdgfote[i], value= jpioretvvc.x/127}
remote.handle_input(msg)
return true
elseif kxcver == 1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= jpioretvvc.x/127}
remote.handle_input(msg2)
return true
end	
end
end
local sdfhaae9ut = 0
for i = 1, 48, 1 do 
local jpioretvvc = remote.match_midi(lnswegfd[i], mhjk4we)
if jpioretvvc ~= nil then 
local reneeder = i - math.floor(i/6)*6
local valogshi = 0
if reneeder == 0 then
sdfhaae9ut = 6
valogshi = i/6 - 1
else
sdfhaae9ut = reneeder
valogshi = math.floor(i/6)
end
if kxcver == 0 then 			
local msg = {time_stamp=mhjk4we.time_stamp, item=dfa34wras[sdfhaae9ut], value= jpioretvvc.y/127}
remote.handle_input(msg)
if jpioretvvc.y/127 ==1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=uiqwassr[sdfhaae9ut], value= valogshi}
remote.handle_input(msg2)
end	
return true
elseif kxcver == 1 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= jpioretvvc.y/127}
remote.handle_input(msg)
return true
end		
end
end
local jpioretvvc = remote.match_midi(nbtygllo, mhjk4we)
if jpioretvvc ~= nil then 
if jpioretvvc.x == 127 then
kxcver = 1
else
kxcver = 0 
local msg = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= 0}
remote.handle_input(msg)
if sdfhaae9ut ~= 0 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= 0}
remote.handle_input(msg2)
return true
end	
end
end			 
end		
otr684dds = nil
otr732dds = nil
trdds43txx = false
function remote_set_state(changed_items)
for i,imbtrdcx in ipairs(changed_items) do
if imbtrdcx == u562werf then
otr684dds = remote.get_item_text_value(u562werf)
if otr684dds == "5" and otr732dds ~= otr684dds then
trdds43txx = true
else
trdds43txx = false
end	
otr732dds = otr684dds
end
if imbtrdcx>=9 and imbtrdcx<=16 then
for i =1, 8, 1 do 
if imbtrdcx == lkjvcds[i] then 
gfhjrsvb[i]=remote.get_item_value(imbtrdcx)
end	
end	
end	
if imbtrdcx>=29 and imbtrdcx <= 76 then
for i =1, 48, 1 do
if imbtrdcx == tcvnfhso[i] then 
pafgskjl[i] = remote.get_item_value(imbtrdcx)
end
end	
end
end	
end			
local function maewrgjj4f(ottre5j)
local i5tteioqq = pommnjhg[ottre5j]
local t43ekgvvf = gfhjrsvb[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 30}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
end
return mhjk4we
end		
local function tr43msdvred(ottre5j)
local i5tteioqq = ertgfsdgb[ottre5j]
local t43ekgvvf = pafgskjl[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 30}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 29}
mhjk4we.size = 3
end	
return mhjk4we
end		
function remote_deliver_midi()
local d34jk5fds={}
if trdds43txx == true then 
for i = 1, 64, 1 do
local la2113wsebv = mv999fdg[i]
mhjk4we={128, la2113wsebv, 0}
mhjk4we.size = 3
table.insert(d34jk5fds, mhjk4we)
end	
trdds43txx = false	
end
for i = 1, 8, 1 do
if chjklwfd[i] ~= gfhjrsvb[i] then
local imbtrdcx = lkjvcds[i]
local mhjk4we = maewrgjj4f(i)
table.insert(d34jk5fds,mhjk4we)
chjklwfd[i] = gfhjrsvb[i]
end
end
for i = 1, 48, 1 do
if nfsvsxvzz[i] ~= pafgskjl[i] then
local imbtrdcx = tcvnfhso[i]
local mhjk4we = tr43msdvred(i)
table.insert(d34jk5fds,mhjk4we)
nfsvsxvzz[i] = pafgskjl[i]
end
end	
if kxcver ~= tslkfgnxz then 
if kxcver == 1 then 
local mhjk4we = {144, 42, 6}
mhjk4we.size = 3
table.insert(d34jk5fds,mhjk4we)
elseif kxcver ==0 then 
local mhjk4we = {144, 42, 0}
mhjk4we.size = 3	
table.insert(d34jk5fds,mhjk4we)
end
tslkfgnxz = kxcver
end
return d34jk5fds
end


function remote_prepare_for_use()
local ret_events = {}
return ret_events
end
function remote_release_from_use()
end










